# Initialize objectives
execute unless entity @a[tag=tntInit] run function tnt:initialize

# If a sticky piston item is present, run function stick
execute as @e[type=item,nbt={Item:{id:"minecraft:sticky_piston",Count:1b}},limit=1] run function tnt:stick

# Make brancher follow primed TNT
execute as @e[type=armor_stand,tag=brancher] at @s if entity @e[type=tnt,distance=..1.5] run tag @s add primed
execute as @e[type=armor_stand,tag=primed,tag=!activeTNT] at @s run tp @s @e[type=tnt,distance=..3,limit=1,sort=nearest]
execute as @e[type=pig,tag=mount] at @s run tp @s @e[type=tnt,distance=..3,limit=1,sort=nearest]
execute as @e[type=pig,tag=mount] at @s if entity @e[type=armor_stand,tag=primed,distance=..1] run tp @s ~ ~0.1 ~
execute as @e[type=armor_stand,tag=charmSwift] at @s run data merge entity @e[type=tnt,distance=..2,nbt={Fuse:80s},limit=1] {Fuse:25}

# Runs mainhalf every other tick
scoreboard players add tnt tntTime 1
execute if score tnt tntTime > tnt1 tntTime run function tnt:mainhalf

# If TNT with sticky piston is broken, run function drop
execute if entity @e[type=item,tag=newDrop,limit=1] run function tnt:drop

# If a primed TNT is about to go off, run the function branch
execute at @e[type=tnt,nbt={Fuse:2s},tag=!branched] run tag @e[type=armor_stand,tag=brancher,distance=..1] add activate
execute if entity @e[type=armor_stand,tag=activate] run function tnt:activate

# If TNT item is present, run function counttnt
execute as @e[type=item,nbt={Item:{id:"minecraft:tnt"}},limit=1] run function tnt:counttnt

# If an active TNT is present, run function active
#execute as @e[type=armor_stand,tag=activeTNT,scores={tntCount=..0}] run kill @s
execute as @e[type=armor_stand,tag=activeTNT,limit=1] run function tnt:active

execute as @e[type=pig,tag=mount] at @s unless block ~ ~ ~ minecraft:tnt unless entity @e[type=armor_stand,tag=brancher,distance=..2] run tp @s ~ ~-50 ~